/*
 * bsp.h
 *
 *  Created on: Jun 27, 2023
 *      Author: hussamaldean
 */

#ifndef BSP_H_
#define BSP_H_


#include "stdint.h"
#include "stm32f4xx.h"



typedef enum
{
	pin0=0,
	pin1,
	pin2,
	pin3,
	pin4,
	pin5,
	pin6,
	pin7,
	pin8,
	pin9,
	pin10,
	pin11,
	pin12,
	pin13,
	pin14,
	pin15
}Pins_Typedef;


typedef enum
{
	INPUT=0,
	OUTPUT,
	Alternate_function,
	Analog_Mode

}GPIO_ModeTypedef;


typedef enum
{
	Push_Pull=0,
	Open_Drain
}GPIO_Output_Type_Typedef;

typedef enum
{
	Low_Speed=0,
	Medium_Speed,
	Fast_Speed,
	High_Speed
}GPIO_OutputSpeed_Typedef;

typedef enum
{
	No_Pullup_PullDown=0,
	PullUp,
	PullDown
}GPIO_PullUPPullDown_Typedef;

typedef enum
{
	AF0=0,
	AF1,
	AF2,
	AF3,
	AF4,
	AF5,
	AF6,
	AF7,
	AF8,
	AF9,
	AF10,
	AF11,
	AF12,
	AF13,
	AF14,
	AF15,

}Alternate_Type_Typedef;


typedef enum
{
	Reset,
	Set

}GPIO_State_Typedef;



typedef enum
{
	AHB1_Prescaler1=0,
	AHB1_Prescaler2=0x8,
	AHB1_Prescaler4=0x09,
	AHB1_Prescaler8=0x0A,
	AHB1_Prescaler16=0x0B,
	AHB1_Prescaler32=0x0C,
	AHB1_Prescaler164=0x0D,
	AHB1_Prescaler128=0x0E,
	AHB1_Prescaler256=0x0F

}AHB1_Prescalers_Typedef;

typedef enum
{
	APB1_Prescaler1=0x00,
	APB1_Prescaler2=0x04,
	APB1_Prescaler4=0x05,
	APB1_Prescaler8=0x06,
	APB1_Prescaler16=0x07
}APB1_Prescalers_Typedef;

typedef enum
{
	APB2_Prescaler1=0x00,
	APB2_Prescaler2=0x04,
	APB2_Prescaler4=0x05,
	APB2_Prescaler8=0x06,
	APB2_Prescaler16=0x07
}APB2_Prescalers_Typedef;


typedef enum
{
	Internal_Oscillator=0,
	External_Oscillator=1
}Clock_Source_Typedef;


typedef enum

{
	Zero_wait_state=0,
	One_wait_state,
	Two_wait_state,
	Three_wait_state,
	Four_wait_state,
	five_wait_state,
	six_wait_state,
	seven_wait_state,
	eight_wait_state,
	nine_wait_state,
	Ten_wait_state,
	Eleven_wait_state,
	Twelve_wait_state,
	Thirteen_wait_state,
	Fourteen_wait_state,
	Fifteen_wait_state
}Flash_Latency_Typedef;


typedef enum
{
	success=0,
	failed=1

}Clock_Config_State_Typedef;


typedef struct
{
	uint8_t PinNumber;
	uint8_t Mode;
	uint8_t OutputType;
	uint8_t OutPutspeed;
	uint8_t PullUp_PullDown;
	uint8_t AlternateType;

}GPIO_Configure_Typedef;



typedef struct
{
	uint8_t pinNumber;
	uint8_t state;
}GPIO_Output_Typedef;

typedef struct
{
	uint8_t pinNumber;
}GPIO_Input_Typedef;



typedef struct
{
	uint8_t clockSourc;

	uint16_t PLL_M;
	uint16_t PLL_N;
	uint16_t PLL_P;

	uint8_t flash_latency;

	uint8_t AHB1Prescaler;
	uint8_t APB1Prescaler;
	uint8_t APB2Prescaler;


}Clock_Config_Typedef;



void GPIOA_CLOCK_ENABLE();

void GPIOC_CLOCK_ENABLE();

void GPIO_Initialization(GPIO_TypeDef *GPIO,GPIO_Configure_Typedef *GPIO_Config);

void GPIO_WritePin(GPIO_TypeDef *GPIO,GPIO_Output_Typedef *GPIOPin, GPIO_State_Typedef state );

void GPIO_TogglePin(GPIO_TypeDef *GPIO,GPIO_Output_Typedef *GPIOPin);

GPIO_State_Typedef GPIO_ReadPin(GPIO_TypeDef *GPIO,GPIO_Input_Typedef *pin);

Clock_Config_State_Typedef Clock_Confgiuration(Clock_Config_Typedef * config);

void BSP_Ticks_Init(uint32_t freq);

uint32_t BSP_Get_Ticks(void);

void BSP_Delay(uint32_t delay_ms);

#endif /* BSP_H_ */
